function CheckboxCreate()
	local yoffset=-65
	local space=27
	function CB1()
			BackgroundFrameShow=ShowBackdropCheckbox:GetChecked()
			if BackgroundFrameShow then 
				mainframe.bg:SetTexture(0.5, 0.5, 0.5); 
				mainframe.bg:SetAlpha(0.5);
				mainframe:EnableMouse(true)
			else
				mainframe.bg:SetTexture(0, 0, 0)
				mainframe.bg:SetAlpha(0);
				mainframe:EnableMouse(false)
			end
		end
	ShowBackdropCheckbox = CreateFrame("CheckButton", "ShowBackdropCheckbox", panel, "ChatConfigCheckButtonTemplate");
	ShowBackdropCheckbox:SetPoint("TOPLEFT", 10, yoffset-1*space)
	ShowBackdropCheckbox:SetChecked(BackgroundFrameShow)
	ShowBackdropCheckbox:SetScript("OnClick", CB1)
	
	ShowBackdropCheckbox.text=ShowBackdropCheckbox:CreateFontString(nil, "OVERLAY")
	ShowBackdropCheckbox.text:SetPoint("LEFT", ShowBackdropCheckbox, "RIGHT")
	ShowBackdropCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ShowBackdropCheckbox.text:SetJustifyH("LEFT")
	ShowBackdropCheckbox.text:SetText("Show / Hide Frame Area")
	CB1()
	ShowBackdropCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking shows addon frame area, configurable by the sliders labeled X Axis Size, and Y Axis Size.  If the player frames generated exceed the vertical height of the frame area, "..
		"frame height will be narrowed such that they fit.  If the player has checked Generate Clickable Frames, frames will continue to build downwards until the player leaves combat, in which they can be resized to fit into the frame area.") end)
	ShowBackdropCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	BattlegroundCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	BattlegroundCheckbox:SetPoint("TOPLEFT", 10, yoffset-2*space)
	BattlegroundCheckbox:SetChecked(BGWork)
	BattlegroundCheckbox:SetScript("OnClick", 
		  function()
			BGWork=BattlegroundCheckbox:GetChecked()
		  end
		);
	BattlegroundCheckbox.text=BattlegroundCheckbox:CreateFontString(nil, "OVERLAY")
	BattlegroundCheckbox.text:SetPoint("LEFT", BattlegroundCheckbox, "RIGHT")
	BattlegroundCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	BattlegroundCheckbox.text:SetJustifyH("LEFT")
	BattlegroundCheckbox.text:SetText("Work in BGs")
	BattlegroundCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking enables generation of frames in a battleground setting.") end)
	BattlegroundCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	ArenaCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	ArenaCheckbox:SetPoint("TOPLEFT", 10, yoffset-3*space)
	ArenaCheckbox:SetChecked(ArenaWork)
	ArenaCheckbox:SetScript("OnClick", 
		  function()
			ArenaWork=ArenaCheckbox:GetChecked()
		  end
		);
	ArenaCheckbox.text=ArenaCheckbox:CreateFontString(nil, "OVERLAY")
	ArenaCheckbox.text:SetPoint("LEFT", ArenaCheckbox, "RIGHT")
	ArenaCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ArenaCheckbox.text:SetJustifyH("LEFT")
	ArenaCheckbox.text:SetText("Work in Arena")
	ArenaCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking enables generation of frames in an arena setting.") end)
	ArenaCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	WorldPvPCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	WorldPvPCheckbox:SetPoint("TOPLEFT", 10, yoffset-4*space)
	WorldPvPCheckbox:SetChecked(WPvPWork)
	WorldPvPCheckbox:SetScript("OnClick", 
		  function()
			WPvPWork=WorldPvPCheckbox:GetChecked()
		  end
		);
	WorldPvPCheckbox.text=WorldPvPCheckbox:CreateFontString(nil, "OVERLAY")
	WorldPvPCheckbox.text:SetPoint("LEFT", WorldPvPCheckbox, "RIGHT")
	WorldPvPCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	WorldPvPCheckbox.text:SetJustifyH("LEFT")
	WorldPvPCheckbox.text:SetText("Work in World PvP")
	WorldPvPCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking enables generation of frames in a non battleground / arena setting.") end)
	WorldPvPCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	TrinketCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	TrinketCheckbox:SetPoint("TOPLEFT", 10, yoffset-5*space)
	TrinketCheckbox:SetChecked(TrinketWork)
	TrinketCheckbox:SetScript("OnClick", 
		  function()
			TrinketWork=TrinketCheckbox:GetChecked()
			AdjustFrameHeights()
		  end
		);
	TrinketCheckbox.text=TrinketCheckbox:CreateFontString(nil, "OVERLAY")
	TrinketCheckbox.text:SetPoint("LEFT", TrinketCheckbox, "RIGHT")
	TrinketCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	TrinketCheckbox.text:SetJustifyH("LEFT")
	TrinketCheckbox.text:SetText("Enable PvP Trinket Tracking")
	TrinketCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking will enable tracking of PvP trinket cooldown for all player frames.  This shows up on the right side of each frame.") end)
	TrinketCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	DRCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	DRCheckbox:SetPoint("TOPLEFT", 10, yoffset-6*space)
	DRCheckbox:SetChecked(DRWork)
	DRCheckbox:SetScript("OnClick", 
		  function()
			DRWork=DRCheckbox:GetChecked()
			AdjustFrameHeights()
		  end
		);
	DRCheckbox.text=DRCheckbox:CreateFontString(nil, "OVERLAY")
	DRCheckbox.text:SetPoint("LEFT", DRCheckbox, "RIGHT")
	DRCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	DRCheckbox.text:SetJustifyH("LEFT")
	DRCheckbox.text:SetText("Enable DR Tracker")
	DRCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking will enable tracking of diminshing returns on crowd control spells on all player frames.  This shows up on the left side of each frame.") end)
	DRCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	
	ClassIconCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	ClassIconCheckbox:SetPoint("TOPLEFT", 10, yoffset-7*space)
	ClassIconCheckbox:SetChecked(ClassIconWork)
	ClassIconCheckbox:SetScript("OnClick", 
		  function()
			ClassIconWork=ClassIconCheckbox:GetChecked()
			AdjustFrameHeights()
		  end
		);
	ClassIconCheckbox.text=ClassIconCheckbox:CreateFontString(nil, "OVERLAY")
	ClassIconCheckbox.text:SetPoint("LEFT", ClassIconCheckbox, "RIGHT")
	ClassIconCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ClassIconCheckbox.text:SetJustifyH("LEFT")
	ClassIconCheckbox.text:SetText("Display Class / Spec")
	ClassIconCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking this will allow display of class / spec icons on the left side of each player frame.") end)
	ClassIconCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	PercentageHPCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	PercentageHPCheckbox:SetPoint("TOPLEFT", 10, yoffset-8*space)
	PercentageHPCheckbox:SetChecked(PercentageHPWork)
	PercentageHPCheckbox:SetScript("OnClick", 
		  function()
			PercentageHPWork=PercentageHPCheckbox:GetChecked()
			AdjustFrameHeights()
		  end
		);
	PercentageHPCheckbox.text=PercentageHPCheckbox:CreateFontString(nil, "OVERLAY")
	PercentageHPCheckbox.text:SetPoint("LEFT", PercentageHPCheckbox, "RIGHT")
	PercentageHPCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	PercentageHPCheckbox.text:SetJustifyH("LEFT")
	PercentageHPCheckbox.text:SetText("Display HP Data on Frame")
	PercentageHPCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking enables display of HP text on the frame.  There are three options for type of text displayed, and can be changed in the dropdown menu, HP Text Type.") end)
	PercentageHPCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	ShowServerCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	ShowServerCheckbox:SetPoint("TOPLEFT", 10, yoffset-9*space)
	ShowServerCheckbox:SetChecked(ShowServerWork)
	ShowServerCheckbox:SetScript("OnClick", 
		  function()
			ShowServerWork=ShowServerCheckbox:GetChecked()
			RemoveAllFrames()
			AdjustFrameHeights()
		  end
		);
	ShowServerCheckbox.text=ShowServerCheckbox:CreateFontString(nil, "OVERLAY")
	ShowServerCheckbox.text:SetPoint("LEFT", ShowServerCheckbox, "RIGHT")
	ShowServerCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ShowServerCheckbox.text:SetJustifyH("LEFT")
	ShowServerCheckbox.text:SetText("Show Server Names")
	ShowServerCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("When checked, the players full name will be displayed on the frame, including server.  With it unchecked, player server will not show.") end)
	ShowServerCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	HealersOnlyCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	HealersOnlyCheckbox:SetPoint("TOPLEFT", 10, yoffset-10*space)
	HealersOnlyCheckbox:SetChecked(HealersOnly)
	HealersOnlyCheckbox:SetScript("OnClick", 
		  function()
			HealersOnly=HealersOnlyCheckbox:GetChecked()
		  end
		);
	HealersOnlyCheckbox.text=HealersOnlyCheckbox:CreateFontString(nil, "OVERLAY")
	HealersOnlyCheckbox.text:SetPoint("LEFT", HealersOnlyCheckbox, "RIGHT")
	HealersOnlyCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	HealersOnlyCheckbox.text:SetJustifyH("LEFT")
	HealersOnlyCheckbox.text:SetText("Show Only Healers")
	HealersOnlyCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("When checked, only player frames for healers will be generated.  Players of unknown spec but potential healing classes will not show up until identified as a healer.") end)
	HealersOnlyCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	ClickableFramesCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	ClickableFramesCheckbox:SetPoint("TOPLEFT", 10, yoffset-11*space)
	ClickableFramesCheckbox:SetChecked(ClickableFrames)
	ClickableFramesCheckbox:SetScript("OnClick", 
		  function()
			ClickableFrames=ClickableFramesCheckbox:GetChecked()
			if not ClickableFrames and _G["PlayerButton" .. 1] then 
				_G["PlayerButton" .. 1]:Hide()
			end
		  end
		);
	ClickableFramesCheckbox.text=ClickableFramesCheckbox:CreateFontString(nil, "OVERLAY")
	ClickableFramesCheckbox.text:SetPoint("LEFT", ClickableFramesCheckbox, "RIGHT")
	ClickableFramesCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ClickableFramesCheckbox.text:SetJustifyH("LEFT")
	ClickableFramesCheckbox.text:SetText("Generate Clickable Frames")
	ClickableFramesCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Clickable frames will be generated.  Left clicking will target the player.  Due to Blizzards API restrictions, " ..
		"the frames CAN NOT be moved during combat.  Frames will immobile during combat, which could result in unsorted frame lists, old frames not disappearing, the frame list building past the bottom of the frame, " ..
		"and new frames found in combat will not be clickable.  Upon leaving combat, " ..
		"the addon will re-sort and regenerate clickable frames for all players currently displayed.") end)
	ClickableFramesCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	DisableClickInRaidCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	DisableClickInRaidCheckbox:SetPoint("TOPLEFT", 10, yoffset-12*space)
	DisableClickInRaidCheckbox:SetChecked(RaidNoClick)
	DisableClickInRaidCheckbox:SetScript("OnClick", 
		  function()
			RaidNoClick=DisableClickInRaidCheckbox:GetChecked()
			if RaidNoClick and UnitInRaid("player") and _G["PlayerButton" .. 1] then 
				_G["PlayerButton" .. 1]:Hide()
			end
		  end
		);
	DisableClickInRaidCheckbox.text=DisableClickInRaidCheckbox:CreateFontString(nil, "OVERLAY")
	DisableClickInRaidCheckbox.text:SetPoint("LEFT", DisableClickInRaidCheckbox, "RIGHT")
	DisableClickInRaidCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	DisableClickInRaidCheckbox.text:SetJustifyH("LEFT")
	DisableClickInRaidCheckbox.text:SetText("Disable Clickable Frames in Raid")
	DisableClickInRaidCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Generation of clickable frames will be disabled while the player is in a raid group. "..
		"This will allow the addon to function as a much more dynamic display while in a PvP raid environment, while sacrificing the ability to click player frames "..
		"that are generated.  Clickable frames will still generate in battlegrounds and arena.  If you are raiding an enemy city, it is likely guards / npcs will hold you in combat for a long period of time, and the frame will not sort players or generate clickable frames "..
		"anyways due to restrictions on Blizzards API.") end)
	DisableClickInRaidCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	TargetCountCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	TargetCountCheckbox:SetPoint("TOPLEFT", 10, yoffset-13*space)
	TargetCountCheckbox:SetChecked(TargetCountEnable)
	TargetCountCheckbox:SetScript("OnClick", 
		  function()
			TargetCountEnable=TargetCountCheckbox:GetChecked()
		  end
		);
	TargetCountCheckbox.text=TargetCountCheckbox:CreateFontString(nil, "OVERLAY")
	TargetCountCheckbox.text:SetPoint("LEFT", TargetCountCheckbox, "RIGHT")
	TargetCountCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	TargetCountCheckbox.text:SetJustifyH("LEFT")
	TargetCountCheckbox.text:SetText("Display Target Count")
	TargetCountCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Checking this will allow display of how many members of your raid or party are targeting each enemy player.") end)
	TargetCountCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	
	StarchCheckbox = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
	StarchCheckbox:SetPoint("TOPLEFT", 10, yoffset-14*space)
	StarchCheckbox:SetChecked(StarchMode)
	StarchCheckbox:SetScript("OnClick", 
		  function()
			StarchMode=TargetCountCheckbox:GetChecked()
		  end
		);
	StarchCheckbox.text=StarchCheckbox:CreateFontString(nil, "OVERLAY")
	StarchCheckbox.text:SetPoint("LEFT", StarchCheckbox, "RIGHT")
	StarchCheckbox.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	StarchCheckbox.text:SetJustifyH("LEFT")
	StarchCheckbox.text:SetText("Identify Starches")
	StarchCheckbox:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Easy to hunt and easy to kill, but are they part of a healthy diet?") end)
	StarchCheckbox:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function CreateTexts()
	Footer=CreateFrame("Button", nil, panel)
	Footer:SetPoint("BOTTOM", panel, "BOTTOM", 0, 20)
	Footer:SetWidth(520)
	Footer:SetHeight(72)
	Footer:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/predatoria_mirror",  
					edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	Footer:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Art by Nachta-Emerald Dream / equusamor on Deviantart \n Guardian-Of-The-Forest, Predatoria") end)
	Footer:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
	Footer:SetScript("OnClick", function () 
		local n=math.random(1,11)
		if n==1 then
			PlaySoundFile("Sound/creature/Tiger/mTigerAggroA.ogg")
		elseif n==2 then
			PlaySoundFile("Sound/creature/Tiger/mTigerAttackA.ogg")
		elseif n==3 then
			PlaySoundFile("Sound/creature/Tiger/mTigerAttackB.ogg")
		elseif n==4 then
			PlaySoundFile("Sound/creature/Tiger/mTigerAttackC.ogg")
		elseif n==5 then
			PlaySoundFile("Sound/creature/Tiger/mTigerAttackD.ogg")
		elseif n==6 then
			PlaySoundFile("Sound/creature/Tiger/mTigerDeathA.ogg")
		elseif n==7 then
			PlaySoundFile("Sound/creature/Tiger/mTigerStand2A.ogg")
		elseif n==8 then
			PlaySoundFile("Sound/creature/Tiger/mTigerWoundA.ogg")
		elseif n==9 then
			PlaySoundFile("Sound/creature/Tiger/mTigerWoundB.ogg")
		elseif n==10 then
			PlaySoundFile("Sound/creature/Tiger/mTigerWoundC.ogg")
		elseif n==11 then
			PlaySoundFile("Sound/creature/Tiger/mTigerWoundCriticalA.ogg")
		end
	end)
	header=CreateFrame("Button", nil, panel)
	header:SetPoint("TOP", panel, "TOP", 0, -10)
	header:SetWidth(520)
	header:SetHeight(72)
	header:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	--[[header.bg = header:CreateTexture("ARTWORK");
	header.bg:SetTexture(0, 0, 0); 
	header.bg:SetAlpha(0.5);
	header.bg:SetWidth(512)
	header.bg:SetHeight(64)
	header.bg:SetPoint("CENTER", header, "CENTER")--]]
	
	header.title=panel:CreateFontString(nil, "OVERLAY")
	header.title:SetPoint("TOP", header, "TOP", 0, -10)
	header.title:SetFont("Fonts\\FRIZQT__.TTF", 180, "THICKOUTLINE")
	header.title:SetJustifyH("CENTER")
	header.title:SetText("PredatorFrames WPvP Player Frames")
	header.title:SetTextColor(168/255, 1, 1)
	
	panel.signature=panel:CreateFontString(nil, "OVERLAY")
	panel.signature:SetPoint("TOP", panel, "TOP", 0, -58)
	panel.signature:SetFont("Fonts\\FRIZQT__.TTF", 16, "THICKOUTLINE")
	panel.signature:SetJustifyH("CENTER")
	panel.signature:SetText("Addon created by Predatoria, Emerald Dream")
	panel.signature:SetTextColor(168/255, 1, 1)
	
	ddm.text=ddm:CreateFontString(nil, "OVERLAY")
	ddm.text:SetPoint("LEFT", ddm, "RIGHT", -10, 5)
	ddm.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ddm.text:SetJustifyH("LEFT")
	ddm.text:SetText("Frame Sorting")
	
	ddm2.text=ddm:CreateFontString(nil, "OVERLAY")
	ddm2.text:SetPoint("LEFT", ddm2, "RIGHT", -10, 5)
	ddm2.text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
	ddm2.text:SetJustifyH("LEFT")
	ddm2.text:SetText("HP Text Type")
end


function ExplanationBoxCreate()
--OnEnter, OnLeave
	ExplanationTextbox=CreateFrame("Frame", nil, panel)
	ExplanationTextbox:SetPoint("BOTTOMRIGHT", panel, "BOTTOMRIGHT", -20, 100)
	ExplanationTextbox:SetWidth(300)
	ExplanationTextbox:SetHeight(120)
	ExplanationTextbox.background=ExplanationTextbox:CreateTexture("ARTWORK")
	ExplanationTextbox.background:SetTexture(0, 0, 0)
	ExplanationTextbox.background:SetAlpha(0.5)
	ExplanationTextbox.background:SetPoint("CENTER", ExplanationTextbox, "CENTER")
	ExplanationTextbox.background:SetWidth(292)
	ExplanationTextbox.background:SetHeight(108)
	ExplanationTextbox:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }});	
	ExplanationTextbox.text=ExplanationTextbox:CreateFontString(nil, "OVERLAY")
	ExplanationTextbox.text:SetWidth(290)
	ExplanationTextbox.text:SetHeight(110)
	ExplanationTextbox.text:SetPoint("CENTER", ExplanationTextbox, "CENTER")
	ExplanationTextbox.text:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
	ExplanationTextbox.text:SetTextColor(168/255, 1, 1)
	ExplanationTextbox.text:SetJustifyH("CENTER")
	ExplanationTextbox.text:SetText("")
end

function DropDownCreate()
	if not DropDownMenuTest then
	   ddm=CreateFrame("Button", "DropDownMenuTest", panel, "UIDropDownMenuTemplate")
	end
	 
	DropDownMenuTest:ClearAllPoints()
	DropDownMenuTest:SetPoint("TOPLEFT", 280, -250)
	DropDownMenuTest:Show()
	 
	local items={
		"Role, Class, Name",
		"Name only, Alphabetical",
		"Class, then Name"}
	 
	local function OnClick(self)
	   UIDropDownMenu_SetSelectedID(DropDownMenuTest, self:GetID())
	   SortStyle=UIDropDownMenu_GetSelectedID(DropDownMenuTest)
	end
	 
	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnClick
	      UIDropDownMenu_AddButton(info, level)
	   end
	end
	UIDropDownMenu_Initialize(DropDownMenuTest, initialize)
	UIDropDownMenu_SetWidth(DropDownMenuTest, 180);
	UIDropDownMenu_SetButtonWidth(DropDownMenuTest, 300)
	UIDropDownMenu_SetSelectedID(DropDownMenuTest, SortStyle)
	UIDropDownMenu_JustifyText(DropDownMenuTest, "LEFT")
	
	ddm:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Set the order in which player frames sort.  If Generate Clickable Frames is checked, frames will only sort out of combat.") end)
	ddm:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function DropDownCreate2()
	if not DropDownMenuTest2 then
	   ddm2=CreateFrame("Button", "DropDownMenuTest2", panel, "UIDropDownMenuTemplate")
	end
	 
	DropDownMenuTest2:ClearAllPoints()
	DropDownMenuTest2:SetPoint("TOPLEFT", 280, -280)
	DropDownMenuTest2:Show()
	 
	local items={
		"Percentage of Max HP",
		"Current HP Only",
		"Current / Max HP"}
	 
	local function OnClick(self)
	   UIDropDownMenu_SetSelectedID(DropDownMenuTest2, self:GetID())
	   HPStyle=UIDropDownMenu_GetSelectedID(DropDownMenuTest2)
	end
	 
	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnClick
	      UIDropDownMenu_AddButton(info, level)
	   end
	end
	UIDropDownMenu_Initialize(DropDownMenuTest2, initialize)
	UIDropDownMenu_SetWidth(DropDownMenuTest2, 180);
	UIDropDownMenu_SetButtonWidth(DropDownMenuTest2, 300)
	UIDropDownMenu_SetSelectedID(DropDownMenuTest2, HPStyle)
	UIDropDownMenu_JustifyText(DropDownMenuTest2, "LEFT")
	
	ddm2:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Set the type of HP text that appears on the frame.  This can be disabled by unchecking Display HP Data on Frame.") end)
	ddm2:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function XSliderCreate()
	XSizeSlider = CreateFrame("Slider", "XSizeSlider", panel, "OptionsSliderTemplate")
	XSizeSlider:SetWidth(300)
	XSizeSlider:SetHeight(20)
	XSizeSlider:SetOrientation('HORIZONTAL')
	XSizeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	XSizeSlider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	XSizeSlider:ClearAllPoints()
	XSizeSlider:SetPoint("TOPLEFT", 300, -100)
	XSizeSliderLow:SetText("Small")
	XSizeSliderHigh:SetText("Large")
	XSizeSliderText:SetText("X Axis Size")
	XSizeSlider:SetMinMaxValues(0,600)
	XSizeSlider:SetValueStep(10)
	XSizeSlider:SetScript("OnValueChanged", 
		function()
			XSize=XSizeSlider:GetValue()
			mainframe:SetWidth(XSize)
			AdjustFrameHeights()
		end
	)
	
	XSizeSlider:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("This sets the width of the player frames.  Check Show / Hide Frame Area to see the area on the screen.") end)
	XSizeSlider:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function YSliderCreate()
	YSizeSlider = CreateFrame("Slider", "YSizeSlider", panel, "OptionsSliderTemplate")
	YSizeSlider:SetWidth(300)
	YSizeSlider:SetHeight(20)
	YSizeSlider:SetOrientation('HORIZONTAL')
	YSizeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	YSizeSlider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	YSizeSlider:ClearAllPoints()
	YSizeSlider:SetPoint("TOPLEFT", 300, -130)
	YSizeSliderLow:SetText("Small")
	YSizeSliderHigh:SetText("Large")
	YSizeSliderText:SetText("Y Axis Size")
	YSizeSlider:SetMinMaxValues(0,700)
	YSizeSlider:SetValueStep(10)
	YSizeSlider:SetScript("OnValueChanged", 
		function()
			YSize=YSizeSlider:GetValue()
			mainframe:SetHeight(YSize)
			AdjustFrameHeights()
		end
	)
	
	YSizeSlider:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("This sets the height of the total frame area.  Check Show / Hide Frame Area to see the area on the screen.  If Generate Clickable Frames is checked and " ..
		"the player is in combat, if many frames generate they will be placed on the end.  When out of combat, the addon will vertically squeeze frames such that they fit into the height of this rectangle.") end)
	YSizeSlider:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function FSliderCreate()
	FSizeSlider = CreateFrame("Slider", "FSizeSlider", panel, "OptionsSliderTemplate")
	FSizeSlider:SetWidth(300)
	FSizeSlider:SetHeight(20)
	FSizeSlider:SetOrientation('HORIZONTAL')
	FSizeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	FSizeSlider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	FSizeSlider:ClearAllPoints()
	FSizeSlider:SetPoint("TOPLEFT", 300, -160)
	FSizeSliderLow:SetText("Small")
	FSizeSliderHigh:SetText("Large")
	FSizeSliderText:SetText("Frame Size")
	FSizeSlider:SetMinMaxValues(1,100)
	FSizeSlider:SetValueStep(1)
	FSizeSlider:SetScript("OnValueChanged", 
		function()
			FrameHeight=FSizeSlider:GetValue()
			AdjustFrameHeights()
		end
	)
	
	FSizeSlider:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("This sets the height of the player frames.  Click the Example button to see some fake player frames and adjust their height.  If more frames generate than can fit in "..
		"the area specified by the Y Axis Size, the addon will narrow the frames, unless the user is in combat and Generate Clickable Frames is checked.") end)
	FSizeSlider:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function NameSliderCreate()
	NameSizeSlider = CreateFrame("Slider", "NameSizeSlider", panel, "OptionsSliderTemplate")
	NameSizeSlider:SetWidth(300)
	NameSizeSlider:SetHeight(20)
	NameSizeSlider:SetOrientation('HORIZONTAL')
	NameSizeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	NameSizeSlider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	NameSizeSlider:ClearAllPoints()
	NameSizeSlider:SetPoint("TOPLEFT", 300, -190)
	NameSizeSliderLow:SetText("Small")
	NameSizeSliderHigh:SetText("Large")
	NameSizeSliderText:SetText("Nameplate Text Size")
	NameSizeSlider:SetMinMaxValues(1,30)
	NameSizeSlider:SetValueStep(1)
	NameSizeSlider:SetScript("OnValueChanged", 
		function()
			FontSize=NameSizeSlider:GetValue()
			AdjustFrameHeights()
		end
	)
	NameSizeSlider:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("This sets the font size of the player name text on the player frames.  Click the Example button to see some example frames.") end)
	NameSizeSlider:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end

function HPSliderCreate()
	HPTextSizeSlider = CreateFrame("Slider", "HPTextSizeSlider", panel, "OptionsSliderTemplate")
	HPTextSizeSlider:SetWidth(300)
	HPTextSizeSlider:SetHeight(20)
	HPTextSizeSlider:SetOrientation('HORIZONTAL')
	HPTextSizeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	FSizeSlider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	HPTextSizeSlider:ClearAllPoints()
	HPTextSizeSlider:SetPoint("TOPLEFT", 300, -220)
	HPTextSizeSliderLow:SetText("Small")
	HPTextSizeSliderHigh:SetText("Large")
	HPTextSizeSliderText:SetText("HP Text Size on Nameplate")
	HPTextSizeSlider:SetMinMaxValues(1,30)
	HPTextSizeSlider:SetValueStep(1)
	HPTextSizeSlider:SetScript("OnValueChanged", 
		function()
			HPFont=HPTextSizeSlider:GetValue()
			AdjustFrameHeights()
		end
	)
	
	HPTextSizeSlider:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("This sets the font size of the HP text on the player frames.  Click the Example button to see some example frames.  HP text type can be configured with "..
		"the HP Text Type dropdown menu.") end)
	HPTextSizeSlider:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end
function TestButtonCreate()
	--[[
	TestButton1=CreateFrame("Button", "only_for_testing1", panel, "UIPanelButtonTemplate")
	TestButton1:SetPoint("TOPLEFT", panel, "TOPLEFT", 10, -50)
	TestButton1:SetWidth(40)
	TestButton1:SetHeight(20)
	TestButton1:SetText("Test1")
	TestButton1:SetScript("OnClick", function()
		print("test1 pressed, adding Nachta")
		--UpgradeFrames(true)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Nachta", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Savage Roar", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
	end)
	
	TestButton2=CreateFrame("Button", "only_for_testing2", panel, "UIPanelButtonTemplate")
	TestButton2:SetPoint("TOPLEFT", panel, "TOPLEFT", 10, -70)
	TestButton2:SetWidth(40)
	TestButton2:SetHeight(20)
	TestButton2:SetText("Test2")
	TestButton2:SetScript("OnClick", function()
		print("test2 pressed, adding Predatoria")
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Predatoria", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Savage Roar", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
	
	end)
	
	TestButton3=CreateFrame("Button", "only_for_testing3", panel, "UIPanelButtonTemplate")
	TestButton3:SetPoint("TOPLEFT", panel, "TOPLEFT", 10, -90)
	TestButton3:SetWidth(40)
	TestButton3:SetHeight(20)
	TestButton3:SetText("Test3")
	TestButton3:SetScript("OnClick", function()
		print("test3 pressed, adding TestPlayer3")
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Scaw-Wildhammer", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Bestial Wrath", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		--RemoveFrame("TestPlayer1")
	end)--]]
	
	TestButton4=CreateFrame("Button", "only_for_testing4", panel, "UIPanelButtonTemplate")
	TestButton4:SetPoint("TOPLEFT", panel, "TOPLEFT", 400, -310)
	TestButton4:SetWidth(130)
	TestButton4:SetHeight(30)
	TestButton4:SetText("Example Frames")
	TestButton4:SetScript("OnClick", function()
		--print("test4 pressed, adding TestPlayer4")
		--for i=1, 9 do
		--	eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Egads"..i, 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "egads", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		--end
		
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Nachta", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Savage Roar", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Predatoria", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Savage Roar", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_AURA_APPLIED", nil, nil, "TestPlayer1", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Kidney Shot", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_AURA_REMOVD", nil, nil, "TestPlayer1", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Kidney Shot", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Player", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Lifebloom", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		eventHandler(nil, "COMBAT_LOG_EVENT_UNFILTERED", nil, "SPELL_CAST_SUCCESS", nil, nil, "Example-Emerald Dream", 0x00000440, nil, nil, nil,  -2487143648, nil, nil, "Bestial Wrath", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil)
		--InsertFrame("TestPlayer1", "TestPlayer2", nil)
		PlayerHealth["Predatoria"]=350000
		PlayerMaxHealth["Predatoria"]=400000
		PlayerHealth["TestPlayer1"]=15000
		PlayerMaxHealth["TestPlayer1"]=300000
		PlayerHealth["Player"]=200000
		PlayerMaxHealth["Player"]=320000
		PlayerHealth["Nach'ta"]=390000
		PlayerMaxHealth["Nach'ta"]=400000
	end)
	
	TestButton4:SetScript("OnEnter", function() ExplanationTextbox.text:SetText("Generate some example frames to configure the display to your liking.") end)
	TestButton4:SetScript("OnLeave", function() ExplanationTextbox.text:SetText("") end)
end






